/*
 Analog input reads an analog input on analog in 0, prints the value out.
 created 24 March 2006
 by Tom Igoe
 */
#include <FastLED.h>   
#define LED_PIN     13
#define UP_PIN     5
#define DOWN_PIN     4
#define NUM_LEDS    50

const CRGB COLOR_BLACK = CRGB(0, 0, 0);
const CRGB COLOR_RED = CRGB(10, 0, 0);
const CRGB COLOR_YELLOW = CRGB(25, 10, 0);
const CRGB COLOR_GREEN = CRGB(0, 10, 0);
const CRGB COLOR_BLUE = CRGB(0, 0, 10);
const CRGB COLOR_WHITE = CRGB(10, 10, 10);

CRGB leds[NUM_LEDS];

void setup() {
  // open the serial port at 9600 bps:
  Serial.begin(9600);
  FastLED.addLeds<WS2812, LED_PIN, GRB>(leds, NUM_LEDS);
  pinMode(UP_PIN, INPUT);
  pinMode(DOWN_PIN, INPUT);
}

int upButtonState = LOW;
int downButtonState = LOW;
int level = 0;

void loop() {
  int newUpButtonState = digitalRead(UP_PIN);
  if (newUpButtonState == HIGH && upButtonState == LOW) { // detect button press
    Serial.println("UP PRESSED");  
    // increase pollution level 
    if (level < 4) {
      level = level + 1;    
    }
  }
  // update current state
  upButtonState = newUpButtonState;

  int newDownButtonState = digitalRead(DOWN_PIN);
  if (newDownButtonState == HIGH && downButtonState == LOW) { // detect button press
    Serial.println("DOWN PRESSED");  
    // decrease pollution level
    if (level > 0) {
      level = level - 1;    
    }
  }  

  // update current state
  downButtonState = newDownButtonState;
  
  Serial.println(level);  
  
  // apply pollution level to led strip
  setPollution(level);
  delay(10);
}

//int isPressedDown(int previousState,int currentState) {
//  
//}

void setPollution(int level) {
    switch (level) {
      case 0:
        setStrip(0, COLOR_RED);
        setStrip(1, COLOR_BLACK);
        setStrip(2, COLOR_BLACK);
        setStrip(3, COLOR_BLACK);
        setStrip(4, COLOR_BLACK);
        break;
      case 1:
        setStrip(0, COLOR_YELLOW);
        setStrip(1, COLOR_YELLOW);
        setStrip(2, COLOR_BLACK);
        setStrip(3, COLOR_BLACK);
        setStrip(4, COLOR_BLACK);
        break;
      case 2:
        setStrip(0, COLOR_GREEN);
        setStrip(1, COLOR_GREEN);
        setStrip(2, COLOR_GREEN);
        setStrip(3, COLOR_BLACK);
        setStrip(4, COLOR_BLACK);
        break;
      case 3:
        setStrip(0, COLOR_BLUE);
        setStrip(1, COLOR_BLUE);
        setStrip(2, COLOR_BLUE);    
        setStrip(3, COLOR_BLUE);  
        setStrip(4, COLOR_BLACK);      
        break;
      case 4:
        setStrip(0, COLOR_WHITE);
        setStrip(1, COLOR_WHITE);
        setStrip(2, COLOR_WHITE);
        setStrip(3, COLOR_WHITE);
        setStrip(4, COLOR_WHITE);
        break;
    }
    FastLED.show();
}

void setStrip(int stripId, CRGB color) {
  for (int i=0;i<10;i++) {
    leds[i+stripId*10] = color;
  }
}
